#include "stdafx.h"
#include "../../../code/vc6/alpha1/src/blepo.h"
#include "../LogTrace/Trace.h"
using namespace blepo;
#include "match_vnk.h"
#include "energy.h"
#include "diffuse.h"
#include "bnutility.h"

void MatchVNK::PredictOcclusion()
{
  Figure fig;
  fig.Draw(mk_label);

  /*for(int i=min_label; i<max_label; i++)
    for(int j=(i+1); j<=max_label; j++)
    {
      if(IsNeighborCCImage(mk_label,j,i))
      {
        int occ_val1 = i;
        int occ_val2 = j;

        Trace("occ_val1 is %d\n",occ_val1);
        Trace("occ_val2 is %d\n",occ_val2);

        std::vector<Point> occ1, occ2;
        std::vector<Point> occ1_opp, occ2_opp;
        // gives the occluded region strips on both sides and also opposite occulsion
        OcclusionAffineWarp(occ_val1,occ_val2,&occ1,&occ2,&occ1_opp,&occ2_opp);*/

  std::vector<Point> points;
  fig.GrabMouseClicks(2,&points);

  int occ_val1 = mk_label(points[0].x,points[0].y);
  int occ_val2 = mk_label(points[1].x,points[1].y);

  Trace("occ_val1 is %d\n",occ_val1);
  Trace("occ_val2 is %d\n",occ_val2);

  std::vector<Point> occ1, occ2;
  std::vector<Point> occ1_opp, occ2_opp;
  // gives the occluded region strips on both sides and also opposite occulsion
  OcclusionAffineWarp(occ_val1,occ_val2,&occ1,&occ2,&occ1_opp,&occ2_opp);

  TracePointArray(occ1);
  TracePointArray(occ2);
  TracePointArray(occ1_opp);
  TracePointArray(occ2_opp);

  std::vector<Point> bp1, bp2;
  NeighborRegionBoundary(occ_val1,occ_val2,&bp1,&bp2);

  Trace("Tracing boundary points\n");
  TracePointArray(bp1);
  TracePointArray(bp2);

  ImgBgr occ_img(mk_width, mk_height);
  ImgInt occ_img_int(mk_width, mk_height);
  ImgBgr occ_opp_img(mk_width, mk_height);
  ImgBgr boundary_img(mk_width, mk_height);
  Set(&occ_img, Bgr(0,0,0));
  Set(&occ_img_int, 255);
  Set(&occ_opp_img, Bgr(0,0,0));
  Set(&boundary_img, Bgr(0,0,0));

  ImgBgr occ_img_orig;
  ImgGray ref_img_gray;
  Convert(mk_ref_img,&ref_img_gray);
  Convert(ref_img_gray, &occ_img_orig);
  
  std::vector<Point>::const_iterator occ1_p;
  for(occ1_p=occ1.begin(); occ1_p!=occ1.end(); occ1_p++)
  {
    occ_img(occ1_p->x,occ1_p->y) = Bgr(0,255,0);
    occ_img_int(occ1_p->x,occ1_p->y) = 0;
    occ_img_orig(occ1_p->x,occ1_p->y) = Bgr(0,0,255);
  }

  std::vector<Point>::const_iterator occ2_p;
  for(occ2_p=occ2.begin(); occ2_p!=occ2.end(); occ2_p++)
  {
    occ_img(occ2_p->x,occ2_p->y) = Bgr(255,0,0);
    occ_img_int(occ2_p->x,occ2_p->y) = 255;
  }

  std::vector<Point>::const_iterator occ1_opp_p;
  for(occ1_opp_p=occ1_opp.begin(); occ1_opp_p!=occ1_opp.end(); occ1_opp_p++)
    occ_opp_img(occ1_opp_p->x,occ1_opp_p->y) = Bgr(0,255,0);

  std::vector<Point>::const_iterator occ2_opp_p;
  for(occ2_opp_p=occ2_opp.begin(); occ2_opp_p!=occ2_opp.end(); occ2_opp_p++)
    occ_opp_img(occ2_opp_p->x,occ2_opp_p->y) = Bgr(255,0,0);

  std::vector<Point>::const_iterator b1_p;
  for(b1_p=bp1.begin(); b1_p!=bp1.end(); b1_p++)
    boundary_img(b1_p->x,b1_p->y) = Bgr(0,255,0);

  std::vector<Point>::const_iterator b2_p;
  for(b2_p=bp2.begin(); b2_p!=bp2.end(); b2_p++)
    boundary_img(b2_p->x,b2_p->y) = Bgr(255,0,0);

  Figure fig2;
  fig2.Draw(occ_img);

  Figure fig2aa;
  fig2aa.Draw(occ_img_int);

  Figure fig2a;
  fig2a.Draw(occ_opp_img);

  Figure fig2b;
  fig2b.Draw(boundary_img);

  Figure fig3;
  fig3.Draw(occ_img_orig);

  char* path_occ_img_orig = "../../output/occ.ppm";
  Save(occ_img_orig,path_occ_img_orig,"ppm");

  /*ImgGray occ_img_gray;
  Convert(occ_img_int,&occ_img_gray);
  char* path_occ = "C:/Research/Cppexp/FinalMonth/InteractiveMerge/output/occ_mot.pgm";
  Save(occ_img_gray,path_occ,"pgm");

  AfxMessageBox("ok");

  occ_val1 = conn_mod(conn_mod_regions[0].x,conn_mod_regions[0].y);
  occ_val2 = conn_mod(conn_mod_regions[1].x,conn_mod_regions[1].y);
  std::vector<float> occ_residue;
  //std::vector<float> occ_residue;
  // gives 4 resdiues - combination for 2 occluded strips and 2 affine params
  OccludedRegionsResidue(img1,img2,occ_val1,occ_val2,occ1,occ2,result_conn_mod_r,
                         &occ_residue); // &occ_opp_residue);

  //if(((occ_residue[0]+occ_residue[1])/2) < ((occ_residue[2]+occ_residue[3])/2))
  if( ((occ_residue[0]+occ_residue[1])/2) < ((occ_residue[2]+occ_residue[3])/2) ||
      RelativePerc(occ_residue[0], occ_residue[1]) < 
      RelativePerc(occ_residue[2], occ_residue[3]) )
  {
    Trace("Region clicked first(region %d) is foreground\n",occ_val1);
    Trace("Region clicked second(region %d) is background\n",occ_val2);
    fore_back->push_back(occ_val1);
    fore_back->push_back(occ_val2);
    *occ = occ1;
  }
  else
  {
    Trace("Region clicked first(region %d) is background\n",occ_val1);
    Trace("Region clicked second(region %d) is foreground\n",occ_val2);
    fore_back->push_back(occ_val2);
    fore_back->push_back(occ_val1);
    *occ = occ2; 
  }

  TraceFloatArray(occ_residue);*/
}

void MatchVNK::OcclusionAffineWarp(
  const int val1,
  const int val2,
  std::vector<Point>* loc1_occlusion,
  std::vector<Point>* loc2_occlusion,
  std::vector<Point>* loc1_opp_occlusion,
  std::vector<Point>* loc2_opp_occlusion)
{
  Trace("Inside OcclusionAffineWarp\n");
  Trace("calculating normal occlusion pixels\n");

  std::vector<Point> loc1_region_points;
  std::vector<Point> loc2_region_points;
  FindPixels(mk_label, val1, &loc1_region_points);
  FindPixels(mk_label, val2, &loc2_region_points);

  MatFlt A1(2,2), d1(1,2); 

  A1(0,0) = *((mk_stb_disp_func[val1]).Begin(0,0));
  A1(1,0) = *((mk_stb_disp_func[val1]).Begin(1,0));
  A1(0,1) = *((mk_stb_disp_func[val1]).Begin(3,0));
  A1(1,1) = *((mk_stb_disp_func[val1]).Begin(4,0));

  d1(0,0) = *((mk_stb_disp_func[val1]).Begin(2,0));
  d1(0,1) = *((mk_stb_disp_func[val1]).Begin(5,0));

  float centroid1_x = mk_stb_centroid_x[val1];
  float centroid1_y = mk_stb_centroid_y[val1];

  MatFlt A2(2,2), d2(1,2);

  A2(0,0) = *((mk_stb_disp_func[val2]).Begin(0,0));
  A2(1,0) = *((mk_stb_disp_func[val2]).Begin(1,0));
  A2(0,1) = *((mk_stb_disp_func[val2]).Begin(3,0));
  A2(1,1) = *((mk_stb_disp_func[val2]).Begin(4,0));

  d2(0,0) = *((mk_stb_disp_func[val2]).Begin(2,0));
  d2(0,1) = *((mk_stb_disp_func[val2]).Begin(5,0));

  float centroid2_x = mk_stb_centroid_x[val2];
  float centroid2_y = mk_stb_centroid_y[val2];

  std::vector<Point>::const_iterator loc1_p;
  for(loc1_p=loc1_region_points.begin(); loc1_p!=loc1_region_points.end(); loc1_p++)
  {
    MatFlt loc_in(1,2), loc_out(1,2), loc_reverse(1,2), loc_reverse_in(1,2);
    loc_in(0,0) = ((float) loc1_p->x) - centroid1_x;
    loc_in(0,1) = ((float) loc1_p->y) - centroid1_y;
    loc_out = A1*loc_in + d1;
    loc_out(0,0) += centroid1_x;
    loc_out(0,1) += centroid1_y;

    loc_reverse_in(0,0) = loc_out(0,0) - centroid2_x - d2(0,0);
    loc_reverse_in(0,1) = loc_out(0,1) - centroid2_y - d2(0,1);

    MatFlt A2inv(2,2);
//    A2inv = Inverse(A2);
    loc_reverse = A2inv*loc_reverse_in;
    loc_reverse(0,0) += centroid2_x;
    loc_reverse(0,1) += centroid2_y;

    int xt=0, yt=0;
    if(FloatPointVal(loc_reverse(0,0),loc_reverse(0,1),val2,&xt,&yt))
      loc1_occlusion->push_back(*loc1_p);
  }

  std::vector<Point>::const_iterator loc2_p;
  for(loc2_p=loc2_region_points.begin(); loc2_p!=loc2_region_points.end(); loc2_p++)
  {
    MatFlt loc_in(1,2), loc_out(1,2), loc_reverse(1,2), loc_reverse_in(1,2);
    loc_in(0,0) = ((float) loc2_p->x) - centroid2_x;
    loc_in(0,1) = ((float) loc2_p->y) - centroid2_y;
    loc_out = A2*loc_in + d2;
    loc_out(0,0) += centroid2_x;
    loc_out(0,1) += centroid2_y;

    loc_reverse_in(0,0) = loc_out(0,0) - centroid1_x - d1(0,0);
    loc_reverse_in(0,1) = loc_out(0,1) - centroid1_y - d1(0,1);

    MatFlt A1inv(2,2);
//    A1inv = Inverse(A1);
    loc_reverse = A1inv*loc_reverse_in;
    loc_reverse(0,0) += centroid1_x;
    loc_reverse(0,1) += centroid1_y;

    int xt=0, yt=0;
    if(FloatPointVal(loc_reverse(0,0),loc_reverse(0,1),val1,&xt,&yt))
      loc2_occlusion->push_back(*loc2_p);
  }

  Trace("calculating opposite occlusion pixels\n");

  MatFlt A1_opp = A1;
  MatFlt d1_opp = -d1;

  MatFlt A2_opp = A2;
  MatFlt d2_opp = -d2;

  for(loc1_p=loc1_region_points.begin(); loc1_p!=loc1_region_points.end(); loc1_p++)
  {
    MatFlt loc_in(1,2), loc_out(1,2), loc_reverse(1,2), loc_reverse_in(1,2);
    loc_in(0,0) = ((float) loc1_p->x) - centroid1_x;
    loc_in(0,1) = ((float) loc1_p->y) - centroid1_y;
    loc_out = (A1_opp*loc_in + d1_opp);
    loc_out(0,0) += centroid1_x;
    loc_out(0,1) += centroid1_y;

    loc_reverse_in(0,0) = loc_out(0,0) - centroid2_x - d2_opp(0,0);
    loc_reverse_in(0,1) = loc_out(0,1) - centroid2_y - d2_opp(0,1);

    MatFlt A2inv(2,2);
//    A2inv = Inverse(A2_opp);
    loc_reverse = A2inv*loc_reverse_in;
    loc_reverse(0,0) += centroid2_x;
    loc_reverse(0,1) += centroid2_y;

    int xt=0, yt=0;
    if(FloatPointVal(loc_reverse(0,0),loc_reverse(0,1),val2,&xt,&yt))
      loc1_opp_occlusion->push_back(*loc1_p);
  }

  for(loc2_p=loc2_region_points.begin(); loc2_p!=loc2_region_points.end(); loc2_p++)
  {
    MatFlt loc_in(1,2), loc_out(1,2), loc_reverse(1,2), loc_reverse_in(1,2);
    loc_in(0,0) = ((float) loc2_p->x) - centroid2_x;
    loc_in(0,1) = ((float) loc2_p->y) - centroid2_y;
    loc_out = (A2_opp*loc_in + d2_opp);
    loc_out(0,0) += centroid2_x;
    loc_out(0,1) += centroid2_y;

    loc_reverse_in(0,0) = loc_out(0,0) - centroid1_x - d1_opp(0,0);
    loc_reverse_in(0,1) = loc_out(0,1) - centroid1_y - d1_opp(0,1);

    MatFlt A1inv(2,2);
//    A1inv = Inverse(A1_opp);
    loc_reverse = A1inv*loc_reverse_in;
    loc_reverse(0,0) += centroid1_x;
    loc_reverse(0,1) += centroid1_y;

    int xt=0, yt=0;
    if(FloatPointVal(loc_reverse(0,0),loc_reverse(0,1),val1,&xt,&yt))
      loc2_opp_occlusion->push_back(*loc2_p);
  }

}

bool MatchVNK::FloatPointVal(
  const float xf, 
  const float yf,
  const int val,
  int* xo,
  int* yo)
{
  int x = (int) xf;
  int y = (int) yf;

  if(x>=0 && x<mk_width && y>=0 && y<mk_height)
    if(mk_label(x,y) == val)
    {
      *xo = x;
      *yo = y;
      return true;
    }

  x += 1;
  if(x>=0 && x<mk_width && y>=0 && y<mk_height)
    if(mk_label(x,y) == val)
    {
      *xo = x;
      *yo = y;
      return true;
    }

  y += 1;
  if(x>=0 && x<mk_width && y>=0 && y<mk_height)
    if(mk_label(x,y) == val)
    {
      *xo = x;
      *yo = y;
      return true;
    }

  x -= 1;
  if(x>=0 && x<mk_width && y>=0 && y<mk_height)
    if(mk_label(x,y) == val)
    {
      *xo = x;
      *yo = y;
      return true;
    }

  return false;
}

// expects connected components image only
void MatchVNK::NeighborRegionBoundary(
  const int val1,
  const int val2,
  std::vector<Point>* boundary1,
  std::vector<Point>* boundary2)
{
  std::vector<int> index, npixels, correspond;
  std::vector<Point> first_point;
  ConnectedComponentsMyInfoOut(mk_label,mk_label,&index,&npixels,&first_point,&correspond);

  std::vector<int> val_v;
  val_v.push_back(val1);
  val_v.push_back(val2);
  std::vector<Point> first_point_v;
  first_point_v.push_back(first_point[val1]);
  first_point_v.push_back(first_point[val2]);
  std::vector<bool> unique;
  std::vector<IntVect> boundary_values_v;
  std::vector<PointVect> boundaries_v;
  RegionBoundariesOut(mk_label,val_v,first_point_v,&boundaries_v,&boundary_values_v,&unique);

  if(unique[0] == true)
  {
    if((boundary_values_v[0])[0] == val2)
      *boundary1 = boundaries_v[0];
  }
  else
  {
    std::vector<int>::const_iterator bvs_p;
    std::vector<Point>::const_iterator b_p;
    for(bvs_p=(boundary_values_v[0]).begin(), b_p=(boundaries_v[0]).begin();
        bvs_p!=(boundary_values_v[0]).end(); bvs_p++, b_p++)
      if(*bvs_p == val2)
        boundary1->push_back(*b_p);
  }
  if(unique[1] == true)
  {
    if((boundary_values_v[1])[0] == val1)
      *boundary2 = boundaries_v[1];
  }
  else
  {
    std::vector<int>::const_iterator bvs_p;
    std::vector<Point>::const_iterator b_p;
    for(bvs_p=(boundary_values_v[1]).begin(), b_p=(boundaries_v[1]).begin();
        bvs_p!=(boundary_values_v[1]).end(); bvs_p++, b_p++)
      if(*bvs_p == val1)
        boundary2->push_back(*b_p);
  }
  
}